% $Id: AveragesTest.oz,v 1.1 2012/03/27 15:42:08 leavens Exp $
\insert 'FloatTesting.oz'
\insert 'Averages.oz'
declare
fun lazy {RepeatingListOf Elements} % A helper for testing only
   {Append Elements {RepeatingListOf Elements}}
end
fun {FromToBy From To By}  % A helper for testing only
   %% REQUIRES: By \= 0.0 and none of From, To, or By is NaN.
   %% ENSURES: result is the finite list [From From+By From+2*By ... To]
   if (By > 0.0 andthen From > To) orelse (By < 0.0 andthen From < To)
   then nil
   else From|{FromToBy From+By To By}
   end
end
{StartTesting 'AveragesTest $Revision: 1.1 $'}
{WithinTest {List.take {Averages
                        {RepeatingListOf [[1.0] [1.0 2.0] [1.0 2.0 3.0] [1.0 2.0 3.0 4.0]
                                          {FromToBy 1.0 100.0 1.0} {FromToBy 1.0 1000.0 1.0}
                                         ]}}
             7} '~=~' [1.0 1.5 2.0 2.5 50.5 500.5 1.0]}
{WithinTest {List.take {Averages
                        {RepeatingListOf [[~1.0] [~1.0 ~2.0] [~1.0 ~2.0 3.0] [~1.0 ~2.0 3.0 4.0]
                                          {FromToBy ~1.0 ~100.0 ~1.0} {FromToBy ~1.0 ~1000.0 ~2.0}
                                         ]}}
             7} '~=~' [~1.0 ~1.5 0.0 1.0 ~50.5 ~500.0 ~1.0]}
{WithinTest {List.take {Averages
                        {RepeatingListOf [{FromToBy 0.0 6000.0 3.0} {FromToBy 0.0 3.0e3 100.0}
                                         ]}}
             4} '~=~' [3000.0 1500.0 3000.0 1500.0]}
{WithinTest {List.take {Averages
                        {RepeatingListOf {Map {FromToBy 1.0 10.0 1.0} fun {$ N} [0.0 N 2.0*N] end}}}
             10} '~=~' {FromToBy 1.0 10.0 1.0}}
{DoneTesting}
